
def            var highlight       as int init 0.
def            var selection       as char. 
def            var ch              as char.
def            var i               as int init 1.
def            var x               as int.
def            var oldhigh         as int.
def            var j               as int.
def            var c-title         as char format "x(80)".
def            var mentry          as char format "x"     extent 8.
def            var menu-line       as char format "x(34)" extent 8.
def            var action          as int.
def            var kblabel-GO      as char no-undo.
def            var kblabel-END     as char no-undo.
def            var t-mail-msg      as char format "x(15)".
def            var ii              as int no-undo.
def            var flag            as logical no-undo.

/* checks if mail is pending */
procedure has-mail:
   def output parameter t-mail-msg as character.
   def var have-mail as int.

   input thru value("nice mail -e 2> /dev/null ; echo $?") no-echo.
   import unformatted have-mail.
   input close.
   
   if have-mail = 0
   then
     t-mail-msg = "YOU HAVE MAIL!".
   else
     t-mail-msg = "    No mail   ".
end.

run has-mail (output t-mail-msg).

assign kblabel-GO   = kblabel("GO")
       kblabel-END  = kblabel("END-ERROR")
       .

/* wide menu format */
form mentry[1]      format "xx"    at 2
     menu-line[1]   format "x(34)" at 5
     mentry[5]      format "xx"    at 41
     menu-line[5]   format "x(34)" at 44    skip
     mentry[2]      format "xx"    at 2
     menu-line[2]   format "x(34)" at 5
     mentry[6]      format "xx"    at 41
     menu-line[6]   format "x(34)" at 44    skip
     mentry[3]      format "xx"    at 2
     menu-line[3]   format "x(34)" at 5
     mentry[7]      format "xx"    at 41
     menu-line[7]   format "x(34)" at 44    skip
     mentry[4]      format "xx"    at 2
     menu-line[4]   format "x(34)" at 5
     mentry[8]      format "xx"    at 41
     menu-line[8]   format "x(34)" at 44    skip
     with width 80 frame fw no-label row 2
          title " POCKY - GreenVille GSO TIPR632K ".

clear all.
hide all.

def var menu-desc as char init "Example Menu".
def var entry-list as char init "L,E,S,M,C,D,,Q".
def var entry-desc as char extent 8 init ["List", "Edit","Simple Display","Sub-Menu","Calculator","Calendar","","Quit"].
def var funct-list as char extent 8 init ["Display Such and Such Report", "Edit the Thus and So","A couple of display statements.","Another Menu","Popup Calculator","Popup Calendar","","Leave Application"].

proc:
repeat on endkey undo, retry:

   assign x       = integer((50 - length(menu-desc)) / 2)
          c-title = " "                                 +
                    string("P2J", "x(14)")   +
                    string( fill(" ", x) +
                            menu-desc, "x(48)") +
                    string(today, "99/99/9999")                       +
                    " "                                 +
                    string(time, "hh:mm")               +
                    " ".
   color display message c-title with frame f-hdr.
   display c-title
           with frame f-hdr no-labels no-box row 1.
   hide message.
   status default.
   put screen color normal row screen-lines + 1
              fill(" ", 78).
   put screen color normal row screen-lines + 2
              fill(" ", 78).

   /* display menu here */
   display entry(1, entry-list)                    @ mentry[1]
           entry-desc[1]                   @ menu-line[1]
           entry(2, entry-list)                    @ mentry[2]
           entry-desc[2]                   @ menu-line[2]
           entry(3, entry-list)                    @ mentry[3]
           entry-desc[3]                   @ menu-line[3]
           entry(4, entry-list)                    @ mentry[4]
           entry-desc[4]                   @ menu-line[4]
           entry(5, entry-list)                    @ mentry[5]
           entry-desc[5]                   @ menu-line[5]
           entry(6, entry-list)                    @ mentry[6]
           entry-desc[6]                   @ menu-line[6]
           entry(7, entry-list)                    @ mentry[7]
           entry-desc[7]                   @ menu-line[7]
           entry(8, entry-list)                    @ mentry[8]
           entry-desc[8]                   @ menu-line[8]
        with frame fw.
        
   /* 1st thing we will do is clear the previous command line */
   put screen color message row (screen-lines - 1) column 4
            fill(" ", 74).
   
   put screen color message row (screen-lines - 1) column 4
                  "[" + kblabel-GO + "]" + "-Launch ".
   
    /* don't check mail between menu's */

    put screen row 19 column 32 color messages 
        "[ " + t-mail-msg + " ]".
 
   /* find first menu entry to highlight */
   if selection = "" then
   do:
      do j = 1 to 8:
         if entry(j, entry-list) <> "" then
         do:
            highlight = j.
            leave.
         end.
      end.
      selection = entry(highlight, entry-list).
   end.
   else
      do:
         do j = 1 to 8:
            if entry(j, entry-list) = selection then
            do:
               highlight = j.
               leave.
            end.
         end.
      end.

   /* display menu selection */
   if highlight > 0 then
   do:
      put screen color messages
                 row (highlight + if highlight <= 4 then 2 else -2)
                 column (if highlight <= 4 then 6 else 45)
                 string(entry-desc[highlight],"x(34)").

    put screen color normal  row (screen-lines) column 4
        "Function: " +
        string(funct-list[highlight],"x(35)").
  end.

  /* show the user what menu we're on */
  put screen color normal row (screen-lines) column 49
      fill(" ", 32).
  put screen color normal row (screen-lines) column 49
      "Menu: " + menu-desc.

  oldhigh = highlight.

  /* get key press from user */
  getkey:
  do while true on endkey undo proc, retry proc:

    readkey-loop:
    do while true:
      readkey pause 60.
      action = lastkey.
      
      if action = -1 then
      do:
        assign i       = integer((50 - length(menu-desc)) / 2)
               c-title = " "               +
                         string("P2J","x(14)")  + 
                         fill(" ", i)      +
                         menu-desc +
                         fill(" ", i)      +
                         string(today)     +
                         " "               +
                         string(time, "hh:mm") +
                         " ".
        color display message c-title with frame f-hdr.
        display c-title with frame f-hdr.
        
        /* only check mail every 15 iterations of readkey */
        ii = ii + 1.
        if ii = 15
        then do:

          ii = 0.
          
          run has-mail (output t-mail-msg).
          put screen row 19 column 32 color messages 
              "[ " + t-mail-msg + " ]".
              
        end. /* if ii = 15 */
      end. /* if action = -1 */
      else
        leave.
    end. /* readkey-loop: do while true */

   /* hide the cursor */
   if oldhigh > 0 then
      put screen color normal
                 row    (oldhigh + if oldhigh <= 4 then 2 else -2)
                 column (if oldhigh <= 4 then 6 else 45)
                 string(entry-desc[oldhigh],"x(34)").

   /* keypress: left cursor */
   if keyfunction(action) = "CURSOR-LEFT" then
   do:
        if highlight <= 4 /* ALREADY ON LEFT */
        then
          bell.
        else do:
          /*** TRY TO MOVE THEM STRAIGHT ACROSS - IF NOT POSSIBLE THEN
               MOVE TO THE NEAREST SELECTION ***/
         if entry(highlight - 4, entry-list) <> ""
         then do:
           highlight = highlight - 4.
         end.
         else do:
           /*** CAN'T GO STRAIGHT ACCROSS ***/
           do j = highlight - 4 to 4:
             if entry(j, entry-list) <> ""
             then do:
               highlight = j.
               leave.
             end.
             if j = 4
             then do: /* TRY FINDING FUNCTION ABOVE */
               do j = highlight - 4 to 1 by -1:
                 if entry(j, entry-list) <> ""
                 then do:
                   highlight = j.
                   leave.
                 end.
               end.
               leave.
             end.
           end.
         end.
        end.
        selection = entry(highlight, entry-list).
        next proc.
      end.

      /*                      KEYPRESS: RIGHT CURSOR
      */
      if keyfunction(action) = "CURSOR-RIGHT"
      then do:
        
        if highlight > 4 /*** ALREADY ON RIGHT!! ***/
        then do:
          bell.
        end.
        else do:
          /*** TRY TO MOVE THEM STRAIGHT ACCROSS - IF NOT POSSIBLE THEN
               MOVE TO THE NEAREST SELECTION ***/
          if entry(highlight + 4, entry-list) <> ""
          then do:
            highlight = highlight + 4.
          end.
          else do:
            /*** CAN'T GO STRAIGHT ACCROSS ***/
            do j = highlight + 4 to 8:
              if entry(j, entry-list) <> ""
              then do:
                highlight = j.
                leave.
              end.
              if j = 32
              then do:
                do j = highlight + 4 to 5 by -1:
                  if entry(j, entry-list) <> ""
                  then do:
                    highlight = j.
                    leave.
                  end.
                end.
                leave.
              end.
            end.
          end.
        end.
        selection = entry(highlight, entry-list).
        next proc.
      end.

    /*                        KEYPRESS: UP CURSOR
    */
    if keyfunction(action) = "CURSOR-UP"
    then do:
      
      do j = highlight - 1 to 1 by -1:
        if j > 0 and entry(j, entry-list) <> ""
        then do:
          highlight = j.
          leave.
        end.
      end.
      selection = entry(highlight, entry-list).
      next proc.
    end.

    /* keypress: down cursor */
    if keyfunction(action) = "CURSOR-DOWN" or action = 32 then
    do:  
      /* go to next available line */
      do j = highlight + 1 to 8:
        if entry(j, entry-list) <> ""
        then do:
          highlight = j.
          leave.
        end.
      end.
      selection = entry(highlight, entry-list).
      next proc.
    end.

    /* keypress: home key */
    if keyfunction(action) begins "HOME"
    then do:
      
      do j = 1 to 8:
        if entry(j, entry-list) <> ""
        then do:
          highlight = j.
          leave.
        end.
      end.
      selection = entry(highlight, entry-list).
      next proc.
    end.

    /* endkey pressed */
    if keyfunction(action) = "END-ERROR" then quit.

    /* reset flag */
    flag = false.
    
    if keyfunction(action) = "RETURN" or keyfunction(action) = "GO" then 
       do:
          /* return key pressed */
          flag = true.
       end.
    else
       do:
          /* check keypress to see if it matches any current menu selection */
          ch = chr(action).
          
          do j = 1 to 8:
             if entry(j, entry-list) = ch then
             do:
                highlight = j.
                flag = true.
             end.
          end.
       end.
    
    /* process a menu selection */
    if flag then
    do:
       selection = entry(highlight, entry-list). 
       
       /* execute the menu choice */
       case selection:
          when "L" then run down1.p.
          when "E" then run down3.p.
          when "S" then run display_stmt.p.
          when "M" then run sub_menu.p.
          when "C" then run util/calculator.p.
          when "D" then run util/calendar.p.
          when "Q" then quit.
       end.
       
       next PROC.
    end.
    
  end. /* getkey */
end. /* repeat proc: */

hide message.
status default.
put screen color normal row screen-lines - 1
           fill(" ", 78).
put screen color normal row screen-lines
           fill(" ", 78).
hide all no-pause.

